---------------
-- Namespace --
---------------
local LDB = LibStub:GetLibrary("LibDataBroker-1.1")

nanoPlayed = CreateFrame("Frame")
nanoPlayed.obj = LDB:NewDataObject("nanoPlayed",
				   {
					   type	= "data source",
					   icon	= "Interface\\Icons\\INV_Misc_PocketWatch_03",
					   label	= "nanoPlayed",
					   text	= "0s",
				   })

---------------
-- Functions --
---------------
local function TimeStr(seconds)
	local tm = seconds
	local timeval = tostring(math.floor(tm % 60)).."s"

	if (tm >= 60) then 
		tm = tm / 60
		timeval = tostring(math.floor(tm % 60)).."m"..timeval

		if (tm >= 60) then
			tm = tm / 60
			timeval = tostring(math.floor(tm % 24)).."h"..timeval

			if (tm >= 24) then
				tm = tm / 24
				timeval = tostring(math.floor(tm)).."d"..timeval
			end
		end
	end
	return timeval
end


--------------------
-- Event Handlers --
--------------------
nanoPlayed:SetScript("OnEvent",
		     function(self, event, ...)
			     if self[event] then
				     return self[event](self, event, ...)
			     end
		     end
	     )


function nanoPlayed:PLAYER_LOGIN()
	LibStub("tekKonfig-AboutPanel").new(nil, "nanoPlayed")
	self.epoch = GetTime()
	self:UnregisterEvent("PLAYER_LOGIN")
	self.PLAYER_LOGIN = nil
end


function nanoPlayed:OnUpdate()
	self.obj.text = TimeStr(GetTime() - self.epoch)
end


nanoPlayed:SetScript("OnUpdate", nanoPlayed.OnUpdate)

if (IsLoggedIn()) then
	nanoPlayed:PLAYER_LOGIN()
else
	nanoPlayed:RegisterEvent("PLAYER_LOGIN")
end